var log4js = require('log4js');
var logger = log4js.getLogger('express');

var express = require('express');
var path = require('path');

var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');

var ioRoute = require('./routes/io');
var dbproxyRoute = require('./routes/dbproxy');

var fs = require('fs');
var path = require('path');

var app = express();
app.set('views', path.resolve(__dirname, './views'));
// app.set('x-powered-by', 'enhancer');

app.use(bodyParser.json({limit: '2mb'}));
app.use(bodyParser.urlencoded({ extended: false, limit: '2mb' }));
app.use(cookieParser());

app.use(ioRoute);
app.use(dbproxyRoute);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
    var err = new Error('Not Found');
    err.status = 404;
    next(err);
});

// error handlers

// development error handler
// will print stacktrace
if (app.get('env') === 'development') {
    app.use(function(err, req, res, next) {
        res.status(err.status || 500);
        console.log( err.stack );
        res.send( err.message );
    });
}

// production error handler
// no stacktraces leaked to user
app.use(function(err, req, res, next) {
    if (err.status === 404) {
        return res.status(404)
            .send('404 not found');
    }
    // res.status(err.status || 500);
    logger.error('request params: ', req.params);
    logger.error('request query:', req.query);
    logger.error('request body:', req.body);
    logger.error( err.stack );
    res.send({
        success: false,
        message: err.message
    });
});

module.exports = app;
